#!/usr/bin/env perl

use strict;
use warnings;

use CGI;
use DBI;
use Data::Dumper;
use HTML::Template;
use HTML::Template::Expr;
use Jcode;

use constant	DATA_SOURCE	=>	'dbi:Pg:dbname=test';
use constant	DB_USER		=>	'www';
use constant	DB_PASSWORD	=>	undef;
use constant	DB_SCHEMA	=>	'kansaipm';

MAIN:{
	my $mode	=	1;	# ǥץڤؤޤ
	my $user_id	=	2;
	my $db		=	connect_db();
	my $user	=	get_user( $db, $user_id );
	my $tmpl;
	
	$tmpl	=	load_tmpl1( 'sample1.tmpl', $db )	if $mode == 1;
	$tmpl	=	load_tmpl2( 'sample2.tmpl', $db )	if $mode == 2;
	$tmpl	=	load_tmpl3( 'sample3.tmpl', $db )	if $mode == 3;
	$tmpl	=	load_tmpl4( 'sample4.tmpl', $db )	if $mode == 4;
	
	# 桼ǡHashPrefixդƥƥץ졼ȤϿ
	$tmpl->param( map { ( "user_$_" => $user->{$_} ) } keys %$user );
	
	# ɽԹShift_JISѴ
	print Jcode::convert( $tmpl->output, 'sjis', 'euc' );
	
	$db->disconnect;
}

sub load_tmpl1	{
	my $file	=	shift;
	my $db		=	shift;
	my $use_lang_list;
	my $lang_list_key	=	'__lang_list';
	
	my $lang_list_filter	=	sub {
		my $text_ref	=	shift;
		
		# ॿ̾Υƥץ졼ȥִ
		if( $$text_ref	=~	s/<TMPL_LANG_LOOP>/<TMPL_LOOP NAME='$lang_list_key'>/ig )	{
			$$text_ref	=~	s!</TMPL_LANG_LOOP>!</TMPL_LOOP>!ig;
			
			# ǥǡϿ뤿˥ե饰
			$use_lang_list	=	1;
		}
	};
	
	my $tmpl	=	HTML::Template->new(
		filename	=>	$file,
		filter		=>	$lang_list_filter,	# ե륿
		global_vars	=>	1,
		die_on_bad_params	=>	0,
	);
	
	if( $use_lang_list )	{
		# ǡϿ
		$tmpl->param( $lang_list_key => lang_list( $db ) );
	}
	
	return $tmpl;
}

sub load_tmpl2	{
	my $file	=	shift;
	my $db		=	shift;
	my $use_lang_list;
	my $lang_list_key	=	'__lang_list';
	
	my $lang_list	=	<<TMPL;
<ul>
<TMPL_LOOP NAME="$lang_list_key">
	<li><TMPL_VAR NAME='name' ESCAPE='HTML'></li>
</TMPL_LOOP>
</ul>
TMPL
	
	my $lang_list_filter	=	sub {
		my $text_ref	=	shift;
		
		# ॿƥץ졼Ȥ֤
		if( $$text_ref =~ s/<TMPL_LANG_LIST>/$lang_list/ig )	{
			# ǥǡϿ뤿˥ե饰
			$use_lang_list	=	1;
		}
	};
	
	my $tmpl	=	HTML::Template->new(
		filename	=>	$file,
		filter		=>	$lang_list_filter,	# ե륿
		global_vars	=>	1,
		die_on_bad_params	=>	0,
	);
	
	if( $use_lang_list )	{
		# ǡϿ
		$tmpl->param( $lang_list_key => lang_list( $db ) );
	}
	
	return $tmpl;
}

# load_tmpl1Ȥΰ㤤
# HTML::TemplateǤϤʤHTML::Template::ExprȤäƤȤǤ
sub load_tmpl3	{
	my $file	=	shift;
	my $db		=	shift;
	my $use_lang_list;
	my $lang_list_key	=	'__lang_list';
	
	my $lang_list_filter	=	sub {
		my $text_ref	=	shift;
		
		if( $$text_ref	=~	s/<TMPL_LANG_LOOP>/<TMPL_LOOP NAME='$lang_list_key'>/ig )	{
			$$text_ref	=~	s!</TMPL_LANG_LOOP>!</TMPL_LOOP>!g;
			$use_lang_list	=	1;
		}
	};
	
	# HTML::Template::Expr
	my $tmpl	=	HTML::Template::Expr->new(
		filename	=>	$file,
		filter		=>	$lang_list_filter,
		global_vars	=>	1,
		die_on_bad_params	=>	0,
	);
	
	if( $use_lang_list )	{
		$tmpl->param( $lang_list_key => lang_list( $db ) );
	}
	
	return $tmpl;
}

sub load_tmpl4	{
	my $file	=	shift;
	my $db		=	shift;
	my $count	=	0;
	my %params;
	
	my $query_loop_filter	=	sub {
		my $text_ref	=	shift;
		
		# ɽϤʤŬǤ(^^;
		$$text_ref	=~	s{
			<TMPL_QUERY_LOOP\s+QUERY=([\'\"])(.+?)\1\s*>
		}{
			my $key		=	sprintf "__query_loop%d", ++$count;
			my $query	=	CGI::unescapeHTML( $2 );
			$params{$key}	=	get_list_by_query( $db, $query );
			"<TMPL_LOOP NAME='$key'>";
		}xieg;
		$$text_ref	=~	s!</TMPL_QUERY_LOOP>!</TMPL_LOOP>!g;
	};
	
	my $tmpl	=	HTML::Template->new(
		filename	=>	$file,
		filter		=>	$query_loop_filter,
		global_vars	=>	1,
		die_on_bad_params	=>	0,
	);
	
	$tmpl->param( %params );
	
	return $tmpl;
}

sub connect_db	{
	my $db		=	DBI->connect( DATA_SOURCE, DB_USER, DB_PASSWORD );
	if( DB_SCHEMA )	{
		$db->do( sprintf( 'SET SEARCH_PATH TO "%s"', DB_SCHEMA ) );
	}
	return $db;
}

sub lang_list	{
	my $db		=	shift;
	my $query	=	qq! SELECT * FROM "lang" ORDER BY id!;
	return $db->selectall_arrayref( $query, { Columns => {} } );
}

sub get_user	{
	my $db		=	shift;
	my $id		=	shift;
	my $query	=	qq! SELECT * FROM "users" WHERE id = ?!;
	return $db->selectrow_hashref( $query, undef, $id );
}

sub get_list_by_query	{
	my $db		=	shift;
	my $query	=	shift;
	return $db->selectall_arrayref( $query, { Columns => {} } );
}


